/* 
TEST KÓD PRE ZÁKLADNÚ DOSKU DENUINO FUTURE V1.0

AK STE ÚPLNÝ ZAČIATOČNÍK A NIDKY STE NEPRACOVALI S RIADIACOU JEDNOTKOU OD Espressif: ESP32, PROSÍM
PRED ZAČATÍM SI STIAHNITE OVLÁDAČ ESP32 modulu v ARDUINO IDE, BOARDS MANAGER:
1. "esp32 by Espressif" (vyhladajte esp32 a kliknite na INSTALL)
2. Zvoľte základnú dosku "ESP32 Dev Module" v Tools. (horný menu bar)
3. Zvoľte vhodný PORT.

PRE SPRÁVNU FUNKČNOSŤ JE POTREBNÉ STIAHNUŤ POTREBNÉ KNIŽNICE PRIAMO Z ARDUINO IDE, SEKCIA KNIŽNICE: 
1. "TFT_eSPI by Bodmer" (vyhladajte TFT_eSPI a kliknite na INSTALL)
2. "PNGdec by Larry Bank" (vyhladajte PNGdec a kliknite na INSTALL)

Po inštalácii knižníc prosím skopírujte celý TFT_eSPI priečinok
do:  /Dokumenty/Arduino/libraries

V priečinku sa nachádzajú inicializačné súbory pre ovládanie ST7789 LCD Modulu: 
1. /TFT_eSPI/User_Setup_Select.h 
2. /User_Setups/Setup203_ST7789.h 

Ovjavíte v nich dáta o rozlíšení LCD obrazovky a potrebných IO pinov. 
Bez týchto údajov bohužial LCD nebude fungovať.

Môžete začat testovať. :)
CRTL+U (upload code)

Ak potrebujete pomoc, neváhajte nás konktaktovať.
info@denuino.sk
*/

#include <TFT_eSPI.h> // TFT Knižnica
#include "test.h"     // Súbor fotografie C Array
#include <PNGdec.h>   // Knižnica na dekódovanie súboru C Array

int LCD_BACKLIGHT = 32; //podsvietenie lcd obrazovky
//-------------------------------------------------------------------- ST7789
PNG png;
  #define MAX_IMAGE_WDITH 240 
  TFT_eSPI tft = TFT_eSPI();       
  int16_t xpos = 0;
  int16_t ypos = 0;
  bool loadImage(const uint8_t* imageData, size_t imageSize) {
  uint8_t* imageDataNonConst = const_cast<uint8_t*>(imageData);
  int16_t rc = png.openRAM(imageDataNonConst, imageSize, pngDraw);
//-------------------------------------------------------------------- ST7789
  if (rc == PNG_SUCCESS) {
    tft.startWrite();
    rc = png.decode(NULL, 0);
    tft.endWrite();
    return true;
  }
    return false;
}
//-------------------------------------------------------------------- ST7789
void pngDraw(PNGDRAW *pDraw) {
  uint16_t lineBuffer[MAX_IMAGE_WDITH];          
  uint8_t  maskBuffer[1 + MAX_IMAGE_WDITH / 8];  
  png.getLineAsRGB565(pDraw, lineBuffer, PNG_RGB565_BIG_ENDIAN, 0xffffffff);
  if (png.getAlphaMask(pDraw, maskBuffer, 255)) {
  tft.pushMaskedImage(xpos, ypos + pDraw->y, pDraw->iWidth, 1, lineBuffer, maskBuffer);
  }
}
//-------------------------------------------------------------------- ST7789

void setup() {  // KÓD SA TU SPUSTÍ 1 KRÁT 
  analogWrite(LCD_BACKLIGHT, 255);  // Zapnutie LCD Podsvietenia
  tft.begin();                      // Inicializácia LCD 
  tft.fillScreen(TFT_WHITE);        // LCD s prázdnym a bielym pozadím na začiatku

  loadImage(test, sizeof(test));    // Načítanie test súboru
}

void loop() { //KÓD SA TU OPAKUJE 
}